/***************************************************************************
 *   Copyright (C) 2003-2005 by Michael Goettsche                          *
 *   mail@tuxipuxi.org                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KSTREAMRIPPER_H
#define KSTREAMRIPPER_H

#include <tdeversion.h>

#include "kstreamripperbase.h"
#include "processcontroller.h"

#include <dnssd/servicebrowser.h>
#include <dnssd/remoteservice.h>


class TQPopupMenu;
class StreamPropertiesDlg;
class TQString;

class KStreamRipper : public KStreamRipperBase
{
    TQ_OBJECT
  

public:

    KStreamRipper( TQWidget* parent = 0, const char* name = 0 );
    ~KStreamRipper();

    virtual void closeEvent( TQCloseEvent* );
    DNSSD::ServiceBrowser m_browser;	

protected slots:

    void addStreamButtonClicked();
    void editStreamButtonClicked();
    void deleteStreamButtonClicked();
    void slotContextMenu( TQListViewItem*, const TQPoint &, int );
    void tuneInButtonClicked();
    void ripButtonClicked();
    void ripStopped(ProcessController*);
    void stopRipButtonClicked();
    void browseButtonClicked();
    void helpButtonClicked();
    void aboutButtonClicked();
    void quitButtonClicked();

    void selectedNewListItem();

    void addStreamFinished( StreamPropertiesDlg* );
    void editStreamFinished( StreamPropertiesDlg* );

    void serviceAdded(DNSSD::RemoteService::Ptr srv);
    void serviceRemoved(DNSSD::RemoteService::Ptr srv);
private:

    TQPopupMenu* contextMenu;
};

#endif

